Imports System.ComponentModel
Imports System.Drawing
Imports System.Windows.Forms
Imports Telerik.Reporting
Imports Telerik.Reporting.Drawing
Imports Telerik.Reporting.Charting

Imports Com.Audisis.LogicaNegocio
Imports Com.Audisis.LogicaNegocio.Configuracion
Imports Com.Audisis.LogicaNegocio.SistemaGestionRiesgos
Imports Com.Audisis.LogicaNegocio.ConsolidadoRiesgo

Partial Public Class ReporteGraficaConsolidadoGeneralRIPorProcesos
    Inherits Telerik.Reporting.Report

    Private _idEmpresa As Integer
    Public Property IdEmpresa() As Integer
        Get
            Return _idEmpresa
        End Get
        Set(ByVal value As Integer)
            _idEmpresa = value
        End Set
    End Property

    Private _idTipoProceso As Integer
    Public Property IdTipoProceso() As Integer
        Get
            Return _idTipoProceso
        End Get
        Set(ByVal value As Integer)
            _idTipoProceso = value
        End Set
    End Property

    Public Shared Function ValorRI() As String
        Return My.Resources.Idioma.ValorRI
    End Function

    Public Shared Function Proceso() As String
        Return My.Resources.Idioma.Procesos
    End Function

    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub Chart1_NeedDataSource(ByVal sender As Object, ByVal e As System.EventArgs) Handles Chart1.NeedDataSource

        Chart1.Legend.Appearance.Position.AlignedPosition = Styles.AlignedPositions.Bottom
        Chart1.Legend.Visible = False

        Dim chartSeries As ChartSeries
        chartSeries = New ChartSeries()
        Chart1.Series.Clear()
        Chart1.PlotArea.XAxis.Clear()
        chartSeries.Type = ChartSeriesType.StackedBar
        chartSeries.Appearance.LabelAppearance.Position.AlignedPosition = Styles.AlignedPositions.Center
        chartSeries.Appearance.TextAppearance.TextProperties.Color = Color.Black
        chartSeries.Appearance.LabelAppearance.LabelLocation = Styles.StyleSeriesItemLabel.ItemLabelLocation.Inside

        Dim consolidadoRiesgoInherente As IConsolidadoRiesgoInherente = _
       LocalizadorServicios.ObtenerServicio(LocalizadorServicios.ConsolidadoRiesgoInherente)
        Dim datosPorProceso As DsEstudio
        Dim prueba, descripcion, concatenado As String
        Dim textArray() As String
        Dim k As Integer

        If IdTipoProceso <> 0 Then
            datosPorProceso = consolidadoRiesgoInherente.ConsultarConsolidadoTipoProcesoDeRiesgoInherentePorProceso(IdTipoProceso, IdEmpresa)
        Else
            datosPorProceso = consolidadoRiesgoInherente.ConsultarConsolidadoGeneralDeRiesgoInherentePorProceso(IdEmpresa)
        End If
        Dim i As Integer = 0

        For Each procesos As DsEstudio.TblEstudioRow In datosPorProceso.TblEstudio.Rows
            chartSeries.AddItem(procesos.valorRiesgoInherente)

            If procesos.colorNivel = "rojo" Then
                chartSeries.Item(i).Appearance.FillStyle.MainColor = Color.Red
                chartSeries.Item(i).Appearance.FillStyle.SecondColor = Color.DarkRed
                chartSeries.Appearance.TextAppearance.TextProperties.Color = Color.Black
                i = i + 1
            ElseIf procesos.colorNivel = "amarillo" Then
                chartSeries.Item(i).Appearance.FillStyle.MainColor = Color.Yellow
                chartSeries.Item(i).Appearance.FillStyle.SecondColor = Color.Gold
                chartSeries.Appearance.TextAppearance.TextProperties.Color = Color.Black
                i = i + 1
            ElseIf procesos.colorNivel = "verde" Then
                chartSeries.Item(i).Appearance.FillStyle.MainColor = Color.LightGreen
                chartSeries.Item(i).Appearance.FillStyle.SecondColor = Color.Green
                chartSeries.Appearance.TextAppearance.TextProperties.Color = Color.Black
                i = i + 1
            End If

            'Colocar los nombres de los procesos
            concatenado = ""
            prueba = procesos.nombreEstudio
            textArray = Split(prueba)
            For k = 0 To textArray.Length - 1
                If textArray(k) <> "" Then
                    If k < 4 Then
                        If textArray(k).Count > 4 Then
                            descripcion = textArray(k).Remove(4)
                            concatenado = concatenado & " " & descripcion
                        End If
                    End If
                End If
            Next
            Chart1.PlotArea.XAxis.AddItem(concatenado)
        Next
        Chart1.PlotArea.XAxis.AutoScale = False
        Chart1.PlotArea.XAxis.Appearance.LabelAppearance.Position.AlignedPosition = False
        Chart1.PlotArea.XAxis.Appearance.LabelAppearance.Position.Auto = False
        Chart1.PlotArea.XAxis.Appearance.LabelAppearance.Position.Y = 20
        Chart1.PlotArea.XAxis.Appearance.LabelAppearance.RotationAngle = 290
        Chart1.PlotArea.XAxis.AutoScale = False
        Chart1.PlotArea.XAxis.Visible = Styles.ChartAxisVisibility.True
        Chart1.PlotArea.XAxis.Appearance.TextAppearance.TextProperties.Color = Color.Black
        Chart1.Series.Add(chartSeries)
    End Sub

End Class